local dmg_buff = 1
local protect = 0
local o
local me, spec
local timer, throttle		= 0, 0.1
local dot_damage, targets	= AffDots.dot_damage, AffDots.targets
local dot_damage_ext = { }
local durSaved = { }
local dot_tiks = { }

function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		for k,v in pairs(AffDots.track) do
			AffDots.track[k].update(AffDots.track[k])
			AffDots:FrameDraw(AffDots.track[k])
		end
       if o.tidyplates.enable and TidyPlates then AffDots:Tidy() end
		timer = 0    
    end
end

local spells = {
	mf				= GetSpellInfo(8921), 	--MF
	sf				= GetSpellInfo(93402),	--SF
	fluidity		= GetSpellInfo(138002), --Fluidity +40%
	nutriment		= GetSpellInfo(140741), --Primal Nutriment +100% +10% per stack
	tricks			= GetSpellInfo(57934),	--Tricks of the Trade + 15%
	fearless		= GetSpellInfo(118977), --Fearless + 60%
	LMG				= GetSpellInfo(137590), -- LMG
	nv				= GetSpellInfo(124974), --Nature's vigil
	inc 			= GetSpellInfo(102560), -- Incarnation
}

local function GetDmgBuffsUpdate()
	dmg_buff = 1
	local fluidity 			= UnitAura("player",	spells.fluidity, nil, "HARMFUL")
	local nutriment 		= UnitAura("player",   spells.nutriment)
	local nv				= UnitAura("player",   spells.nv)
	local tricks 			= UnitAura("player",	  spells.tricks)
	local fearless 			= UnitAura("player",	spells.fearless)
	local inc 				= UnitAura("player",	spells.inc)
	if fluidity 	then dmg_buff = 1.4 					end
	if nutriment 	then dmg_buff = 2					 	end
	if fearless 	then dmg_buff = 1.6 					end
	if tricks 		then dmg_buff = dmg_buff * 1.15			end
	if nv 			then dmg_buff = dmg_buff * 1.10			end
	if inc 			then dmg_buff = dmg_buff * 1.25			end
	return dmg_buff
end

local function Round(num) return math.floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math.floor(num+.5)
	else return math.floor(num*10+.5)/10 end
end

function AffDots:FindColor(GUID,time_left,spell,pandemic)
	if not targets[GUID..spell] or not dot_damage[spell] then
		return 7
	end
	local current 		= dot_damage[spell][1]
	local on_target 	= targets[GUID..spell][1]
	if		on_target  < current then color = 1
	elseif 	on_target == current then color = 2
	elseif	on_target  > current then color = 6
	end
	return color
end

AffDots.Update = {
	dot	= function(f)
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..f.spell] then
			if(math.abs(expires-f.timer)>1) then
				f.datanew.expires = expires
				f.datanew.duration = duration
				f.datanew.setcd = true
				f.timer = expires
			end
			f.datanew.color = o["color"..AffDots:FindColor(guid,expires - GetTime(),f.spell,f.pandemic)]
			f.datanew.tick = targets[guid..f.spell][3]
			f.datanew.t2 = SecondsRound(f.timer-GetTime())
			if o.reltext then
				f.datanew.t1 = Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1])
			elseif o.layout == "bars" then
				f.datanew.t1 = dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]
			else
				f.datanew.t1 = dot_damage[f.spell][1].."\n"..targets[guid..f.spell][1]
			end
		else
			f.datanew.color = o.color7
			f.datanew.t1 = 0
			f.datanew.t2 = ""
			f.datanew.tick = 0
			f.timer = 0
			f.datanew.hidecd = true
		end
	end,
}

local GetDotDmg = {
	
	function()
		haste, crit, spd, eclipse, eclipseenergy, ca = UnitSpellHaste("player"), GetSpellCritChance(6), GetSpellBonusDamage(6), (1.15+GetMasteryEffect()/100), UnitPower("player", SPELL_POWER_ECLIPSE), GetSpellInfo(112071)
		if crit > 100 then crit = 100 end
		damage_bonus 		= (1+crit/100)
		tick_every 			= 2/(1+(haste/100))
		ticks 				= Round(14/tick_every)
		duration 			= ticks * tick_every
		
		if UnitAura("player", ca) then
			damage				= ticks*(263+spd*0.24)*1.15*eclipse*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[8921]		= {Round(dps/100)/10, tick_every, duration, ticks}
			damage				= ticks*(263+spd*0.24)*1.15*eclipse*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[93402]		= {Round(dps/100)/10, tick_every, duration, ticks} else
			
		if eclipseenergy < 0 and GetEclipseDirection() == "sun" then
			damage				= ticks*(263+spd*0.24)*eclipse*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[8921]		= {Round(dps/100)/10, tick_every, duration, ticks}
			else
			damage				= ticks*(263+spd*0.24)*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[8921]		= {Round(dps/100)/10, tick_every, duration, ticks}			
		end
			
		if eclipseenergy > 0 and GetEclipseDirection() == "moon" then		
			damage				= ticks*(263+spd*0.24)*eclipse*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[93402]		= {Round(dps/100)/10, tick_every, duration, ticks}
			else
			damage				= ticks*(263+spd*0.24)*damage_bonus*GetDmgBuffsUpdate()
			dps					= Round(damage/duration)
			dot_damage[93402]		= {Round(dps/100)/10, tick_every, duration, ticks}
			end
			end
		end,
}

local function GetDotDur(arg1)
	local spellname = GetSpellInfo(arg1)
	local duration =	select(6, UnitAura("target", spellname, nil, "PLAYER|HARMFUL")) or 0
	local expiration = 	select(7, UnitAura("target", spellname, nil, "PLAYER|HARMFUL")) or GetTime()
			
	local testtime = expiration-duration
	
	return duration, expiration, testtime
end

local function GetDotTicks(spellID, destGUID)
	
	if dot_tiks[destGUID..""..spellID] and dot_tiks[destGUID..""..spellID] == 0 then
		return true
	else
		return false
	end
end

local function RemoveDotTic(spellID, destGUID)
	if dot_tiks[destGUID..""..spellID] and dot_tiks[destGUID..""..spellID] > 0 then
		dot_tiks[destGUID..""..spellID] = dot_tiks[destGUID..""..spellID] - 1
	end
end

local CombatLog = {
	function(_,_,_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_, ...)		
		if dest_GUID == UnitGUID("player") and select(1, ...) == 137590 then
			AffDots:GetDotDmg()
		end
		if source_GUID ~= me then return end
			spell = select(1, ...)
		if event_type == "SPELL_AURA_APPLIED" then
			if spell == 93402 then
			
					if UnitGUID("target") ==  dest_GUID then
						durSaved[dest_GUID.."93402"] = { select(2, GetDotDur(93402)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."93402"] = { dot_damage[93402][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
					
				targets[dest_GUID.."93402"] = {dot_damage[93402][1],GetTime(),dot_damage[93402][2]}
				dot_tiks[dest_GUID.."93402"] = dot_damage[93402][4]
			elseif spell == 8921 then
					if UnitGUID("target") ==  dest_GUID then
						durSaved[dest_GUID.."8921"] = { select(2, GetDotDur(8921)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."8921"] = { dot_damage[8921][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
					
					targets[dest_GUID.."8921"] = {dot_damage[8921][1],GetTime(),dot_damage[8921][2]}
					dot_tiks[dest_GUID.."8921"] = dot_damage[8921][4]
			
			end
		elseif event_type == "SPELL_AURA_REFRESH" then
			if spell == 93402 and GetTime() - protect > 0.5 then
					if UnitGUID("target") ==  dest_GUID then
						durSaved[dest_GUID.."93402"] = { select(2, GetDotDur(93402)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."93402"] = { dot_damage[93402][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
		
				targets[dest_GUID.."93402"] = {dot_damage[93402][1],GetTime(),dot_damage[93402][2]}
				dot_tiks[dest_GUID.."93402"] = dot_damage[93402][4]
			elseif spell == 8921 and GetTime() - protect > 0.5 then
					if UnitGUID("target") ==  dest_GUID then
						durSaved[dest_GUID.."8921"] = { select(2, GetDotDur(8921)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."8921"] = { dot_damage[8921][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."8921"] = {dot_damage[8921][1],GetTime(),dot_damage[8921][2]}
				dot_tiks[dest_GUID.."8921"] = dot_damage[8921][4]

			end
		elseif event_type == "SPELL_SUMMON" then
			saGUID[dest_GUID] = me
		elseif event_type == "SPELL_DAMAGE" then
			if (spell == 8921 or spell == 93402) then
				protect = GetTime()
			end
		elseif event_type == "SPELL_PERIODIC_DAMAGE" then
			if (spell == 8921 or spell == 93402) then
				RemoveDotTic(spell, dest_GUID)
			end
			end
		end, 
}

function AffDots:InitSpec()
	AffDots:ReleaseFrames()
	wipe(AffDots.track)
	
		AffDots.execute_percent = 20
		AffDots:Track(  8921,	  AffDots.Update.dot, "target",   14,  0, 0,  true)
		AffDots:Track( 93402,	  AffDots.Update.dot, "target",   14,  0, 1,  true)
		if o.focus then
		AffDots:Track(  8921,	  AffDots.Update.dot,  "focus",	  14,  0, 0,  true)
		AffDots:Track( 93402,	  AffDots.Update.dot,  "focus",	  14,  0, 1,  true)
		end
		AffDots.tidyspells = {
	   ["Interface\\Icons\\Spell_Arcane_Moonfire"] = {spell = 8921, pandemic = 0},
	   ["Interface\\Icons\\Spell_Nature_Sunfire"] = {spell = 93402, pandemic = 0},
	}	
	AffDots:InitFrames()
end

function AffDots:InitClass()
	AffDots:RegisterEvent("PLAYER_TALENT_UPDATE", "InitClass")
	me = UnitGUID("player")	
	o = self.db.profile
	AffDots:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	AffDots:UnregisterEvent("COMBAT_RATING_UPDATE")
	AffDots:UnregisterEvent("SPELL_POWER_CHANGED")
	AffDots:UnregisterEvent("UNIT_STATS")
	AffDots:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
	AffDots:UnregisterEvent("PLAYER_REGEN_ENABLED")
	AffDots:UnregisterEvent("PLAYER_REGEN_DISABLED")
	AffDots:UnregisterEvent("PLAYER_FOCUS_CHANGED")
	AffDots:UnregisterEvent("MODIFIER_STATE_CHANGED")
	AffDotsTarget:SetScript("OnUpdate", nil)
	AffDotsTarget:Hide(); AffDotsFocus:Hide(); AffDotsBurst:Hide()
	spec = GetSpecialization() or ""
	if (spec == 1) then
		o = self.db.profile
		AffDots.GetDotDmg = GetDotDmg[spec]
		AffDots.CombatLog = CombatLog[spec]
		AffDots:GetDotDmg()
		AffDots:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")
		AffDots:RegisterEvent("COMBAT_RATING_UPDATE", "GetDotDmg")
		AffDots:RegisterEvent("SPELL_POWER_CHANGED", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_STATS", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_DAMAGE_DONE_MODS", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_SPELL_HASTE", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_AURAS_CHANGED", "GetDotDmg")		
		AffDots:RegisterEvent("PLAYER_REGEN_ENABLED")
		AffDots:RegisterEvent("PLAYER_REGEN_DISABLED")
		AffDots:RegisterEvent("PLAYER_FOCUS_CHANGED")
		AffDots:RegisterEvent("MODIFIER_STATE_CHANGED")
		AffDotsTarget:SetScript("OnUpdate", onUpdate)
		AffDots:InitSpec()
	end
end

function AffDots:GetSpecOptions(spec)
	if spec == "DRUID1" or spec == "DRUID" then	
			self.options.args.spec.name = "Balance"
			self.options.args.spec.args = {
			spacer1 = {
				order = 1,type = "description",name="You are in Balance spec and ready to go! If you have any questions, suggestions or compliments email Joeriftnveda@gmail.com", width="full",
			},
		}
		AffDots:InitClass()
	else	
		self.options.args.spec.name = "Specialization"
		self.options.args.spec.args = {
			spacer1 = {
				order = 1,type = "description",name="You are not in Balance spec!", width="full",
			},
		}
	end
end