﻿local pi = 1 --power infusion
local tof = 1 --Tof

local L = LibStub("AceLocale-3.0"):GetLocale("AffDots")

local dmg_buff = 1
local protect = 0
local rip_protect = 0
local lastspdcof = 1
local pitofcof = 1
local damageboncof = 1
local o
local crit_s = ""
local crit_h = ""
local me, spec
local timer, throttle		= 0, 0.1
local dot_damage, targets	= AffDots.dot_damage, AffDots.targets
local dot_damage_ext = { }
local saGUID = { }
local durSaved = { }
local dot_tiks = { }
local MindBlastFrame

--Locale 

L["Shadow"] = "Shadow"
L["Change SWP and VT postition"] = "Change SWP and VT postition"
L["Turn Off 2p15"] = "Turn Off 2p15"
L["VT"] = "Vampiric Touch"
L["SWP"] = "Shadow Word:Pain"
L["DP"] = "Devouring Plague"
L["ORBS"] = "Shadow Orbs"
L["Show Shadow Word:Pain"] = "Show Shadow Word:Pain"
L["Show Vampiric Touch"] = "Show Vampiric Touch"
L["Show Devouring Plague"] = "Show Devouring Plague"
L["Show Shadow Orbs"] = "Show Shadow Orbs"
L["Update all scales when exteded (for 5.2)"] = "Update all scales when exteded (for 5.2)"
L["Enable Debug"] = "Enable Debug"
L["Show Shadow Word:Death ICD"] = "Show Shadow Word:Death ICD"
L["SWD"] = "Shadow Word:Death"
L["Colors for Shadow Word:Death"] = "Colors for Shadow Word:Death"
L["Can be used"] = "Can be used"
L["ICD"] = "ICD"
L["CD"] = "CD"
L["Show normal dot ticks"] = "Show normal dot ticks"
L["UVLS main prioriry"] = "UVLS main prioriry"
L["Integrate dot colors in ElvUI NamePlates"] = "Integrate dot colors in ElvUI NamePlates"
L["Show Mind Blast"] = "Show Mind Blast"
L["Mind Blast"] = "Mind Blast"

function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		for k,v in pairs(AffDots.track) do
	   AffDots.track[k].update(AffDots.track[k])
	   AffDots:FrameDraw(AffDots.track[k])
	end
	if o.tidyplates.enable and TidyPlates then AffDots:Tidy() end
	if o.shadow.elvui and ElvUI and ElvUI[1].NamePlates and ElvUI[1].NamePlates.enabledState then AffDots:ElvNP() end
	timer = 0
    end
end

local function Round(num) return math.floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math.floor(num+.5)
	else return math.floor(num*10+.5)/10 end
end

local set2t15 = false

function AffDots:Detect2T15()
    set2t15 = false
    local t15items = 0
    local t15set = {
        96674,96675,96676,96677,96678,
        95300,95301,95302,95303,95304,
        95930,95931,95932,95933,95934,
    }
    for i,v in ipairs(t15set) do
        if IsEquippedItem(v) then
            t15items = t15items + 1
        end
    end
    if t15items >= 2 then set2t15 = true end
--	print("CHECK 2t15:",set2t15)
end

local spells = {
	swp				= GetSpellInfo(589), 	--SWP
	vt				= GetSpellInfo(34914),	--VT
	fluidity		= GetSpellInfo(138002), --Fluidity +40%
	nutriment		= GetSpellInfo(140741), --Primal Nutriment +100% +10% per stack
	tricks			= GetSpellInfo(57934),	--Tricks of the Trade + 15%
	fearless		= GetSpellInfo(118977), --Fearless + 60%
	LMG				= GetSpellInfo(137590), -- LMG
	shadowform		= GetSpellInfo(15473),
	powerinfusion   = GetSpellInfo(10060), --power infusiom
	twistoffitg     = GetSpellInfo(123254),
	skullbanner		= GetSpellInfo(114207),
	uvls			= GetSpellInfo(138963),
--	test			= GetSpellInfo(119050), --test
}

local function GetDmgBuffsUpdate()
	dmg_buff = 1
	
	local fluidity 			= UnitAura("player",	spells.fluidity, nil, "HARMFUL")
	local _,_,_,nutriment 	= UnitAura("player",   spells.nutriment)
	local tricks 			= UnitAura("player",	  spells.tricks)
	local fearless 			= UnitAura("player",	spells.fearless)
	local shadowform		= UnitAura("player",	spells.shadowform)
	local pi				= UnitAura("player",	spells.powerinfusion)
	local tof				= UnitAura("player",	spells.twistoffitg)
	local skullbanner		= UnitAura("player",	spells.skullbanner)
	
	if fluidity 	then dmg_buff = dmg_buff * 1.4 			end
	if nutriment 	then dmg_buff = 2 + (nutriment-1)*0.1 	end
	if fearless 	then dmg_buff = dmg_buff * 1.6 			end
	if tricks 		then dmg_buff = dmg_buff * 1.15			end
	
	if GetSpellCritChance(6) >= 100 then
		if skullbanner then dmg_buff = dmg_buff*1.20		end
	end
	
	if pi			then dmg_buff = dmg_buff * 1.05			end
	if tof			then dmg_buff = dmg_buff * 1.15			end
	if shadowform	then dmg_buff = dmg_buff * 1.25			end
	return dmg_buff
end

function AffDots:FindColor(GUID,time_left,spell,pandemic)
    if not targets[GUID..spell] or not dot_damage[spell] then
        return 7
    end
    local color = 2
    local current   = dot_damage[spell][1]
    local on_target    = targets[GUID..spell][1]
    if      on_target*o.color_switch  < current then color = 1
    elseif  on_target  > current then color = 6
    end
    return color
end

local getorb = false
local whengetorb = 0

local function GetSWDtargetHP()
	if UnitExists("target") and UnitCanAttack("player", "target")then
		curhp = ((UnitHealth("target") * 100)/ UnitHealthMax("target"))
		
		if curhp <= 20 and curhp >0 then
			return true
		end
		return false
	end
	return false
end

local function GetDotTicks(spellID, destGUID)	
	if dot_tiks[destGUID..""..spellID] and dot_tiks[destGUID..""..spellID] == 0 then
		return true, dot_tiks[destGUID..""..spellID]
	else
		return false, dot_tiks[destGUID..""..spellID]
	end
end

local function RemoveDotTic(spellID, destGUID)
	if dot_tiks[destGUID..""..spellID] and dot_tiks[destGUID..""..spellID] > 0 then
		dot_tiks[destGUID..""..spellID] = dot_tiks[destGUID..""..spellID] - 1
	end
end

function AffDots:ElvNP()
	local ElvUI_NP = ElvUI[1].NamePlates.Handled
	local frame, time_left, icon, spell, pandemic, GUID, c
	for frame, _ in pairs(ElvUI_NP) do
		frame = _G[frame]:GetChildren()	
		GUID = frame.guid
		
		if GUID then
		
			for id, auraF in pairs(frame.AuraWidget.AuraIconFrames) do
				icon = auraF.Icon:GetTexture()
				if AffDots.tidyspells[icon] then
					spell = AffDots.tidyspells[icon].spell; pandemic = AffDots.tidyspells[icon].pandemic
					time_left = tonumber(string.sub(auraF.TimeLeft:GetText(), 11, -3))
				--	print(time_left, tonumber(auraF.TimeLeft:GetText()), auraF.TimeLeft:GetText(), auraF.TimeLeft:GetText():len(), tonumber(string.sub(auraF.TimeLeft:GetText(), 11, -3)))
				end
				if not auraF.affdots then
					auraF.Icon:SetDrawLayer("ARTWORK")
					auraF.AffBorder = auraF:CreateTexture(nil, "BORDER")
					auraF.AffBorder:SetDrawLayer("BACKGROUND")
					auraF.AffBorder:SetSize(o.tidyplates.w,o.tidyplates.h)
					auraF.AffBorder:SetPoint("CENTER", auraF, "CENTER",0, 0)
					auraF.affdots = true
				end
				if AffDots.tidyspells[icon] then
					if not auraF.AffBorder:IsShown() then
						auraF.AffBorder:Show()
					end
				else
					if auraF.AffBorder:IsShown() then
						auraF.AffBorder:Hide()
					end
				end
				if spell and time_left then
					c = AffDots:FindColor(GUID,time_left,spell,pandemic)
					auraF.AffBorder:SetTexture(o["color"..c][1],o["color"..c][2],o["color"..c][3],o.tidyplates.transparency)
				else
					auraF.AffBorder:SetTexture(1,0,0,o.tidyplates.transparency)
				end
			end
		end
	end
end

AffDots.Update = {
	dot	= function(f)
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..f.spell] then
			if(math.abs(expires-f.timer)>1) then
				f.datanew.expires = expires
				f.datanew.duration = duration
				f.datanew.setcd = true
				f.timer = expires
			end
			f.datanew.color = o["color"..AffDots:FindColor(guid,expires - GetTime(),f.spell,f.pandemic)]
			f.datanew.tick = targets[guid..f.spell][3]
			f.datanew.t2 = SecondsRound(f.timer-GetTime())
			if o.reltext then
				if o.shadow.showticknumber and f.spell ~= 2944 then	
					f.datanew.t1 = Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1])..targets[guid..f.spell][4].."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1])..targets[guid..f.spell][4]
					end
				end
			elseif o.layout == "bars" then
				if o.shadow.showticknumber and f.spell ~= 2944 then
					f.datanew.t1 = dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]..targets[guid..f.spell][4].."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]..targets[guid..f.spell][4]
					end
				end
			else
				if o.shadow.showticknumber and f.spell ~= 2944 then 
					f.datanew.t1 = dot_damage[f.spell][1].."\n"..targets[guid..f.spell][1]..targets[guid..f.spell][4].."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = dot_damage[f.spell][1].."\n"..targets[guid..f.spell][1]..targets[guid..f.spell][4]
					end
				end
			end
		else
			f.datanew.color = o.color7
			f.datanew.t1 = 0
			f.datanew.t2 = ""
			f.datanew.tick = 0
			f.timer = 0
			f.datanew.hidecd = true
		end
	end,
	shadoworbs = function(f)
		local power = UnitPower("player", SPELL_POWER_SHADOW_ORBS)
		local color = 1
		if 		power == 3 then color = 4
		elseif 	power == 2 then color = 2
		elseif 	power == 1 then color = 2
		end
		if power == 0 then
			f.datanew.setw = o.bars.w*0.01/3
		else
			f.datanew.setw = o.bars.w*power/3
		end
		f.datanew.t1 = power
		f.datanew.color = o.color7
	end,
	shadowworddeath = function(f)
		local name = GetSpellInfo(32379);
		local start, duration, enabled = GetSpellCooldown(name)
		
		if start > 0 and duration > 7 then	
			f.datanew.t1 = "CD"
			f.datanew.timer = duration 
			f.datanew.expires = start + duration
			f.datanew.duration = duration
			f.datanew.setcd = true
			f.datanew.color = o.shadow.color3
		--	getorb = false
		elseif getorb and whengetorb then
			f.datanew.t1 = "ICD"
			f.datanew.timer = 6
			f.datanew.expires = whengetorb + 6
			f.datanew.duration = 6
			f.datanew.setcd = true
			f.datanew.color = o.shadow.color2
			
			if GetTime() > (whengetorb + 6) then
				getorb = false
			end
			
		else
			f.datanew.t1 = ""
			f.datanew.hidecd = true
			
			if GetSWDtargetHP() then
				f.datanew.color = o.shadow.color1
			else
				f.datanew.color = o.shadow.color4
			end
		--	getorb = false
		end
	end,
	mindblast = function(f)
		local name = GetSpellInfo(124430)
		local name1 = GetSpellInfo(8092)
		local start, duration, enabled = GetSpellCooldown(name1)
		local glowenable = false
		local diaira = UnitBuff("player", name)
		
		if start > 0 and duration > 6 then 
			
			f.datanew.t1 = "CD"
			f.datanew.timer = duration
			f.datanew.expires = start + duration
			f.datanew.duration = duration
			f.datanew.setcd = true
			f.datanew.color = o.color6
		else
			
			f.datanew.t1 = ""
			f.datanew.hidecd = true
			f.datanew.color = o.color1
		end
		
		if not glowenable and diaira then		
			ActionButton_ShowOverlayGlow(MindBlastFrame)
			glowenable = true
		else
			ActionButton_HideOverlayGlow(MindBlastFrame)
			glowenable = false
		end
	end,
}

local GetDotDmg = {
	function() end,
	function() end,
	function() 
		local mastery, haste, crit, spd, sorbs = GetMastery(), UnitSpellHaste("player"), GetSpellCritChance(6), GetSpellBonusDamage(6), UnitPower("player", SPELL_POWER_SHADOW_ORBS)
		crit_s = ""
		
		if crit >= 100 then
			crit = 100
			crit_s = "c"
		end

		damage_bonus 		= (1+crit/100)*(1+(mastery*1.8)/100)
		tick_every 			= 3/(1+(haste/100))
		
		ticks 				= Round(18/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(623+spd*0.293)*damage_bonus*GetDmgBuffsUpdate()
		dps					= Round(damage/duration)
		dot_damage[589]		= {Round(dps/100)/10, tick_every, duration, ticks, crit_s}
		
		ticks 				= Round(15/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(62+spd*0.346)*damage_bonus*GetDmgBuffsUpdate()
		dps					= Round(damage/duration)
		dot_damage[34914]		= {Round(dps/100)/10, tick_every, duration, ticks, crit_s}
		
		tick_every			= 1/(1+(haste/100))
		ticks 				= Round(6/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(9+spd*0.131)*sorbs*damage_bonus*GetDmgBuffsUpdate()
		dps					= Round(damage/duration)
		dot_damage[2944]		= {Round(dps/100)/10, tick_every, duration, ticks, crit_s}
	end,
	function() end,
}

local function GetDotDur(arg1, destGUID)
	local spellname = GetSpellInfo(arg1)
	local unit = "target"
	
	if destGUID == UnitGUID("focus") then
		unit = "focus"
	elseif destGUID == UnitGUID("boss1") then
		unit = "boss1"
	elseif destGUID == UnitGUID("boss2") then
		unit = "boss2"
	elseif destGUID == UnitGUID("boss3") then
		unit = "boss3"
	elseif destGUID == UnitGUID("boss4") then
		unit = "boss4"
	elseif destGUID == UnitGUID("boss5") then
		unit = "boss5"
	end

	local duration =	select(6, UnitDebuff(unit, spellname, nil, "PLAYER")) or 0
	local expiration = 	select(7, UnitDebuff(unit, spellname, nil, "PLAYER")) or GetTime()
			
	local testtime = expiration-duration
	
	return duration, expiration, testtime
end

local lsttick = {
	[589]   = 0,
	[34914] = 0,
}

local defaul_tick = {
	[589] = 6,
	[34919] = 5,
}

local CombatLog = {
	function()	end,
	function() end,
	function(_,_,_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_, ...)
		if event_type == "SPELL_DAMAGE" and saGUID[source_GUID] == me and set2t15 then
			if dest_GUID == UnitGUID("target") or 
				dest_GUID == UnitGUID("focus") or 
				dest_GUID == UnitGUID("boss1") or 
				dest_GUID == UnitGUID("boss2") or 
				dest_GUID == UnitGUID("boss3") or 
				dest_GUID == UnitGUID("boss4") or 
				dest_GUID == UnitGUID("boss5") then
				
				if durSaved[dest_GUID.."589"] and durSaved[dest_GUID.."589"][1] < select(2, GetDotDur(589, dest_GUID)) then 
					durSaved[dest_GUID.."589"][1] = select(2, GetDotDur(589, dest_GUID))
					if GetDotTicks(589, dest_GUID) then
						targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5]}
					end
				end
				if durSaved[dest_GUID.."34914"] and durSaved[dest_GUID.."34914"][1] < select(2, GetDotDur(34914, dest_GUID)) then
					durSaved[dest_GUID.."34914"][1] = select(2, GetDotDur(34914, dest_GUID))
					if GetDotTicks(34914, dest_GUID) then
						targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5]}
					end
				end
			end
		end
		
		if dest_GUID == UnitGUID("player") and select(1, ...) == 137590 then
			AffDots:GetDotDmg()
		end
		if source_GUID ~= me then return end
		spell = select(1, ...)
		if event_type == "SPELL_AURA_APPLIED" then
			if spell == 34914 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."34914"] = { select(2, GetDotDur(34914, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."34914"] = { dot_damage[34914][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				
					local have_uvls	= UnitAura("player",spells.uvls)
					if have_uvls then
						crit_h = "c"
					else
						crit_h = ""
					end
				targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5]}
				dot_tiks[dest_GUID.."34914"] = dot_damage[34914][4]
		elseif spell == 589 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."589"] = { select(2, GetDotDur(589, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."589"] = { dot_damage[589][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5]}
				dot_tiks[dest_GUID.."589"] = dot_damage[589][4]
			elseif spell == 2944 then
				targets[dest_GUID.."2944"] = {dot_damage[2944][1],GetTime(),dot_damage[2944][2], dot_damage[2944][5]}
			end
		elseif event_type == "SPELL_AURA_REFRESH" then
			
			if spell == 34914 and GetTime() - protect > 0.5 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."34914"] = { select(2, GetDotDur(34914, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."34914"] = { dot_damage[34914][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5]}
				dot_tiks[dest_GUID.."34914"] = dot_damage[34914][4]
			elseif spell == 589 and GetTime() - protect > 0.5 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."589"] = { select(2, GetDotDur(589, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."589"] = { dot_damage[589][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5]}
				dot_tiks[dest_GUID.."589"] = dot_damage[589][4]
			elseif spell == 2944 and GetTime() - protect > 0.5 then
				targets[dest_GUID.."2944"] = {dot_damage[2944][1],GetTime(),dot_damage[2944][2], dot_damage[2944][5]}
			end
		elseif event_type == "SPELL_SUMMON" then
			saGUID[dest_GUID] = me
		elseif event_type == "SPELL_DAMAGE" then
			if (spell == 589 or spell == 34914) then
				protect = GetTime()
			end
		elseif event_type == "SPELL_CAST_SUCCESS" then
			if spell == 32379 then
				getorb = true
				whengetorb = GetTime()
			end
		elseif event_type == "SPELL_PERIODIC_DAMAGE" then
			if (spell == 589 or spell == 34914) then
				RemoveDotTic(spell, dest_GUID)
			end
		end
	end,
	function() end,
}

function AffDots:InitSpec()
	AffDots:ReleaseFrames()
	wipe(AffDots.track)
	AffDots.execute_percent = 20
	AffDots:Track(  34914,	  AffDots.Update.dot,             "target",   15,  0, o.shadow.vt,   o.shadow.show_vt)
	AffDots:Track(  589,	  AffDots.Update.dot,             "target",   18,  0, o.shadow.swp,  o.shadow.show_swp)
	AffDots:Track( 2944,	  AffDots.Update.dot,             "target",   6,   0, o.shadow.dp,   o.shadow.show_dp)
	AffDots:Track(95740,      AffDots.Update.shadoworbs,      "target",   3,   0, o.shadow.orbs, o.shadow.show_orbs)
	AffDots:Track(32379,	  AffDots.Update.shadowworddeath, "target",   2,   0, o.shadow.swd,  o.shadow.show_swd)
	AffDots:Track(8092,		  AffDots.Update.mindblast,		  "target",	  8,   0, o.shadow.mb,	 o.shadow.show_mb)
	
	if o.focus then
		AffDots:Track(  34914,	  AffDots.Update.dot,  "focus",	  15,  0, o.shadow.vt,   o.shadow.show_vt)
		AffDots:Track(    589,	  AffDots.Update.dot,  "focus",	  18,  0, o.shadow.swp,  o.shadow.show_swp)
		AffDots:Track( 2944,	  AffDots.Update.dot,  "focus",   6,   0, o.shadow.dp,   o.shadow.show_dp)
	end
		
	AffDots.tidyspells = {}
	
	if o.shadow.show_swp then
		AffDots.tidyspells["Interface\\Icons\\Spell_Shadow_ShadowWordPain"] = {spell = 589, pandemic = 0}
	end
	if o.shadow.show_vt then
		AffDots.tidyspells["Interface\\Icons\\Spell_Holy_Stoicism"] = {spell = 34914, pandemic = 0}
	end
	if o.shadow.show_dp then
		AffDots.tidyspells["Interface\\Icons\\Spell_Shadow_DevouringPlague"] = {spell= 2944, pandemic = 0}
	end
	
	AffDots:Detect2T15()
	
	AffDots:InitFrames()
	
	for k,v in pairs(AffDots.track) do		
		if AffDots.track[k].spell == 8092 then
			MindBlastFrame = AffDots.track[k].f.icon
		end
	end
end

function AffDots:InitClass()
	AffDots:RegisterEvent("PLAYER_TALENT_UPDATE", "InitClass")
	me = UnitGUID("player")
	o = self.db.profile
	AffDots:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	AffDots:UnregisterEvent("COMBAT_RATING_UPDATE")
	AffDots:UnregisterEvent("SPELL_POWER_CHANGED")
	AffDots:UnregisterEvent("UNIT_STATS")
	AffDots:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
	AffDots:UnregisterEvent("PLAYER_REGEN_ENABLED")
	AffDots:UnregisterEvent("PLAYER_REGEN_DISABLED")
	AffDots:UnregisterEvent("PLAYER_FOCUS_CHANGED")
	AffDots:UnregisterEvent("PLAYER_EQUIPMENT_CHANGED")
	AffDots:UnregisterEvent("MODIFIER_STATE_CHANGED")
	AffDotsTarget:SetScript("OnUpdate", nil)
	AffDotsTarget:Hide(); AffDotsFocus:Hide(); AffDotsBurst:Hide()
	spec = GetSpecialization() or ""
	
	--if o and o.shadow then		
		--	o.shadow.enabled = o.shadow.enabled   or true
		--	o.shadow.saext	 = o.shadow.saext     or true
			
		--	o.shadow.show_swp = o.shadow.show_swp or true
		--	o.shadow.show_vt  = o.shadow.show_vt  or true
		--	o.shadow.show_dp  = o.shadow.show_dp  or false
		--	o.shadow.show_orbs = o.shadow.show_orbs or false
		--	o.shadow.debug 	  = false
		--	o.shadow.uvls 	  = false
			o.shadow 		  = o.shadow 		  or { }
			o.shadow.vt		  = o.shadow.vt		  or 0
			o.shadow.swp	  = o.shadow.swp      or 1
			o.shadow.dp		  = o.shadow.dp		  or 2
			o.shadow.orbs     = o.shadow.orbs     or 3
			o.shadow.swd      = o.shadow.swd      or 4
			o.shadow.mb		  = o.shadow.mb       or 5
			
			o.shadow.color1   = o.shadow.color1	  or {0,0.5,0}		--better
			o.shadow.color2   = o.shadow.color2   or {0.5,0.5,0}		--same
			o.shadow.color3	  = o.shadow.color3   or {0.5,0,0}		--worse
			o.shadow.color4	  = o.shadow.color4   or {0,0,0}			--no dot on target
	--	end
		
	if (spec == 3 and self.db.profile.shadow.enabled ) then
	
		AffDots.GetDotDmg = GetDotDmg[spec]
		AffDots.CombatLog = CombatLog[spec]
		AffDots:GetDotDmg()
		AffDots:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")
		AffDots:RegisterEvent("COMBAT_RATING_UPDATE", "GetDotDmg")
		AffDots:RegisterEvent("SPELL_POWER_CHANGED", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_STATS", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_DAMAGE_DONE_MODS", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_SPELL_HASTE", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_AURAS_CHANGED", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_REGEN_ENABLED")
		AffDots:RegisterEvent("PLAYER_REGEN_DISABLED")
		AffDots:RegisterEvent("PLAYER_FOCUS_CHANGED")
		AffDots:RegisterEvent("MODIFIER_STATE_CHANGED")
		AffDots:RegisterEvent("PLAYER_EQUIPMENT_CHANGED", "Detect2T15")
		AffDotsTarget:SetScript("OnUpdate", onUpdate)
		AffDots:InitSpec()
	end
end

function AffDots:GetSpecOptions(spec)
	if spec == "PRIEST3" or spec == "PRIEST" then
		self.options.args.spec.name = L["Shadow"]
		self.options.args.spec.args = {
		--[[	vtswp = {
				order = 1,name = L["Change SWP and VT postition"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.swpvt = not o.shadow.swpvt; AffDots:InitSpec() end,
				get = function(info) return self.db.profile.shadow.swpvt end
			},	]]	
			shadowspec = {
				order = 1,name = L["Enable"],type = "toggle",
				set = function(info,val) o.shadow.enabled = not o.shadow.enabled; AffDots:InitClass() end,
				get = function() return o.shadow.enabled end
			},
			elvnp = { --o.shadow.elvui
				order = 3,name = L["Integrate dot colors in ElvUI NamePlates"],type = "toggle",
				set = function(info,val) o.shadow.elvui = not o.shadow.elvui; AffDots:InitClass() end,
				get = function() return o.shadow.elvui end
			},
		--[[	shadowspecdebuf = {
				order = 3,name = L["Enable Debug"],type = "toggle",
				set = function(info,val) o.shadow.debug = not o.shadow.debug; AffDots:InitClass() end,
				get = function() return o.shadow.debug end
			},]]
			ticknumber = {
				order = 3,name = L["Show normal dot ticks"],type = "toggle",
				set = function(info,val) o.shadow.showticknumber = not o.shadow.showticknumber; AffDots:InitClass() end,
				get = function() return o.shadow.showticknumber end			
			},
		--[[	uvls = {
				order = 3,name = L["UVLS main prioriry"],type = "toggle",
				set = function(info,val) o.shadow.uvls = not o.shadow.uvls; AffDots:InitClass() end,
				get = function() return o.shadow.uvls end			
			},]]
		--[[	saextend = {
				order = 2,name = L["Turn Off 2p15"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.saext = not o.shadow.saext; AffDots:InitSpec() end,
				get = function(info) return o.shadow.saext end
			},]]
		--[[	fsaextend = {
				order = 2,name = L["Update all scales when exteded (for 5.2)"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.fsaext = not o.shadow.fsaext; AffDots:InitSpec() end,
				get = function(info) return o.shadow.fsaext end
			},]]
			show_swp = {
				order = 3,name = L["Show Shadow Word:Pain"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_swp = not o.shadow.show_swp; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_swp end
			},
			show_vt = {
				order = 3,name = L["Show Vampiric Touch"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_vt = not o.shadow.show_vt; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_vt end
			},
			show_dp = {
				order = 3,name = L["Show Devouring Plague"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_dp = not o.shadow.show_dp; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_dp end
			},
			show_mb = {
				order = 3,name = L["Show Mind Blast"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_mb = not o.shadow.show_mb; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_mb end
			},
			show_orbs = {
				order = 3,name = L["Show Shadow Orbs"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_orbs = not o.shadow.show_orbs; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_orbs end
			},
			show_swd = {
				order = 3,name = L["Show Shadow Word:Death ICD"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.show_swd = not o.shadow.show_swd; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_swd end
			},
			desc = {
				order = 4,name = L["Order:"],type = "description",fontSize="medium"
			},
		--	L["Show Mind Blast"] = "Show Mind Blast"
		--	L["Mind Blast"] = "Mind Blast"
			vt = {
				order = 6,name = L["VT"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.vt = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.vt + 1 end
			},
			swp = {
				order = 6,name = L["SWP"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.swp = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.swp + 1 end
			},
			dp = {
				order = 6,name = L["DP"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.dp = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.dp + 1 end
			},
			mb = {
				order = 6,name = L["Mind Blast"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.mb = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.mb + 1 end
			},
			orbs = {
				order = 6,name = L["ORBS"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.orbs = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.orbs + 1 end
			},
			swd = {
				order = 6,name = L["SWD"],type = "range",
				min = 1,max = 6,step = 1,softMin = 1,softMax=6,
				set = function(info,val) o.shadow.swd = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.swd + 1 end
			},
			
			desc2 = {
				order = 14,name = L["Colors for Shadow Word:Death"],type = "description",fontSize="medium",width="full",
			},
			color1 = {
				order = 16,name = L["Can be used"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color1={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color1[1],self.db.profile.shadow.color1[2],self.db.profile.shadow.color1[3],1 end
			},
			color2 = {
				order = 18,name = L["ICD"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color2={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color2[1],self.db.profile.shadow.color2[2],self.db.profile.shadow.color2[3],1 end
			},
			color3 = {
				order = 20,name = L["CD"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color3={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color3[1],self.db.profile.shadow.color3[2],self.db.profile.shadow.color3[3],1 end
			},
		}
	else
		self.options.args.spec.name = "Specialization"
		self.options.args.spec.args = {
			spacer1 = {
				order = 1,type = "description",name="Specialization not supported, AffDots deactivated", width="full",
			},
		}
	end
end