----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Selin Fireheart"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 18 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.zonename = BZ["Magisters' Terrace"]
mod.enabletrigger = boss 
mod.guid = 24723
mod.toggleOptions = {"channel","bosskill"}

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Selin",

	channel = "Channel Mana",
	channel_desc = "Warn when Selin Fireheart is channeling mana from a Fel Crystal",
	channel_message = "Channeling Mana!",
} end )

L:RegisterTranslations("deDE", function() return {

	channel = "Manakanalisieren",
	channel_desc = "Warnt wenn Selin Feuerherz Mana von einem Teufelskristall kanalisiert",
	channel_message = "Kanalisiert Mana!",
} end )

L:RegisterTranslations("koKR", function() return {
	channel = "분노의 마나",
	channel_desc = "셀린 파이어하트가 지옥 수정에서 마력 흡수에 대해 알립니다.",
	channel_message = "분노의 마나!",
} end )

L:RegisterTranslations("frFR", function() return {
	channel = "Canalise du mana",
	channel_desc = "Prévient quand Selin Coeur-de-feu canalise du mana à partir d'un gangrecristal.",
	channel_message = "Canalise du mana !",
} end )

L:RegisterTranslations("zhCN", function() return {
	channel = "法力通道",
	channel_desc = "当从魔能水晶获取法力时发出警报。",
	channel_message = "法力通道！",
} end )

L:RegisterTranslations("zhTW", function() return {
	channel = "法力通道",
	channel_desc = "當賽林·炎心以魔能水晶獲取法力時發出警報",
	channel_message = "法力通道!",
} end )

L:RegisterTranslations("ruRU", function() return {
	channel = "Вытягивание маны",
	channel_desc = "Предупреждать когда Селин Огненное Сердце начинает высасывать ману из кристалла Скверны",
	channel_message = "Вытягивание маны!",
} end )



----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "Channel", 44320)
	self:AddCombatListener("SPELL_AURA_REMOVED", "ChannelEnd", 44320)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Channel(_, spellId)
	if self.db.profiel.channel then
		self:Message(L["channel_message"], "Important")
		self:Bar(L["channel_message"], 10, spellID)
	end
end

function mod:FeedbackRemove(player)
	if self.db.profile.channel then
		self:TriggerEvent("BigWigs_StopBar", self, L["channel_message"])
	end
end
